' qb quest

RANDOMIZE TIMER

y_max% = 23
x_max% = 80
y_max_m1% = 22
x_max_d2% = 40

'--- read title
RESTORE QB_DOT
DIM qbd%(x_max_d2%, y_max_m1%)

FOR j% = 1 TO y_max_m1%
    FOR i% = 1 TO x_max_d2%
        READ k%
        qbd%(i%, j%) = k%
    NEXT i%
NEXT j%

'--- title
TITLE_SCREEN:

FOR j% = 1 TO y_max_m1%
    FOR i% = 1 TO x_max%
        LOCATE j%, i%
        IF i% > x_max_d2% THEN
            k% = qbd%(x_max% - i%, j%)
        ELSE
            k% = qbd%(i%, j%)
        END IF
        IF k% > 0 THEN
            SELECT CASE k%
                CASE 1: COLOR 12
                CASE 2: COLOR 15
                CASE ELSE
                    COLOR 12
                    IF (i% MOD 10) > 5 THEN COLOR 15
            END SELECT
            PRINT "#"
        ELSE
            PRINT " "
        END IF
    NEXT i%
NEXT j%

COLOR 15
LOCATE 6, 36: PRINT "QB Quest"
LOCATE 8, 35: PRINT "Hit Any Key"
c$ = ANYKEY$
IF c$ = CHR$(27) THEN END

'---init_game
score% = 0
ma_amount% = 0
safe_teleport% = 0

INIT_GAME:
qb_x% = INT(RND * (x_max% - 2)) + 2
qb_y% = INT(RND * (y_max% - 2)) + 2

ma_amount% = ma_amount% + 10
REDIM ma_x%(ma_amount%)
REDIM ma_y%(ma_amount%)
REDIM ma_state%(ma_amount%)
FOR i% = 1 TO ma_amount%
    DO
        ma_x%(i%) = INT(RND * (x_max% - 2)) + 2
        ma_y%(i%) = INT(RND * (y_max% - 2)) + 2
        k% = 0
        FOR j% = 1 TO (i% - 1)
            IF ma_x%(i%) = ma_x%(y%) AND ma_y%(i%) = ma_y%(y%) THEN k% = 1
        NEXT j%
    LOOP UNTIL k% = 0
    ma_state%(i%) = 1
NEXT i%

state% = 1
endwait% = 0

'---game

DO
    _LIMIT 30
    c$ = INKEY$
    IF c$ = CHR$(27) THEN END
    IF (c$ <> "" AND state% = 1) OR state% = 4 THEN
        ' move of qb
        do_safe_teleport% = 0
        IF state% = 1 THEN
            SELECT CASE c$
                CASE "1": qb_x% = qb_x% - 1: qb_y% = qb_y% + 1
                CASE "2": qb_y% = qb_y% + 1
                CASE "3": qb_x% = qb_x% + 1: qb_y% = qb_y% + 1
                CASE "4": qb_x% = qb_x% - 1
                CASE "6": qb_x% = qb_x% + 1
                CASE "7": qb_x% = qb_x% - 1: qb_y% = qb_y% - 1
                CASE "8": qb_y% = qb_y% - 1
                CASE "9": qb_x% = qb_x% + 1: qb_y% = qb_y% - 1
                CASE "0": state% = 4
                CASE "*"
                    qb_x% = INT(RND * (x_max% - 2)) + 2
                    qb_y% = INT(RND * (y_max% - 2)) + 2
                CASE "+"
                    IF safe_teleport% > 0 THEN
                        do_safe_teleport% = 1
                        safe_teleport% = safe_teleport% - 1
                    ELSE
                        qb_x% = INT(RND * (x_max% - 2)) + 2
                        qb_y% = INT(RND * (y_max% - 2)) + 2
                    END IF
            END SELECT
            IF qb_x% = 1 THEN qb_x% = 2
            IF qb_x% = x_max% THEN qb_x% = x_max% - 1
            IF qb_y% = 1 THEN qb_y% = 2
            IF qb_y% = y_max% THEN qb_y% = y_max% - 1

        END IF

        ' move of mahoshojo
        FOR i% = 1 TO ma_amount%
            IF ma_state%(i%) = 1 THEN
                IF ma_x%(i%) < qb_x% THEN ma_x%(i%) = ma_x%(i%) + 1
                IF ma_x%(i%) > qb_x% THEN ma_x%(i%) = ma_x%(i%) - 1
                IF ma_y%(i%) < qb_y% THEN ma_y%(i%) = ma_y%(i%) + 1
                IF ma_y%(i%) > qb_y% THEN ma_y%(i%) = ma_y%(i%) - 1
            END IF
        NEXT i%

        ' safe teleport
        IF do_safe_teleport% = 1 THEN
            DO
                qb_x% = INT(RND * (x_max% - 2)) + 2
                qb_y% = INT(RND * (y_max% - 2)) + 2
                k% = 0
                FOR i% = 1 TO ma_amount%
                    IF ma_x%(i%) = qb_x% AND ma_y%(i%) = qb_y% THEN k% = 1
                NEXT i%
            LOOP UNTIL k% = 0
        END IF

        ' set qb to game over
        FOR i% = 1 TO ma_amount%
            IF ma_x%(i%) = qb_x% AND ma_y%(i%) = qb_y% THEN state% = 2
        NEXT i%

        ' set mahoshojo to majo
        ' and check clear
        k% = 1
        FOR i% = 1 TO ma_amount%
            FOR j% = (i% + 1) TO ma_amount%
                IF ma_x%(i%) = ma_x%(j%) AND ma_y%(i%) = ma_y%(j%) THEN
                    IF ma_state%(i%) = 1 THEN
                        score% = score% + 10
                        IF state% = 4 THEN
                            safe_teleport% = safe_teleport% + 1
                            IF safe_teleport% > 10 THEN safe_teleport% = 10
                        END IF
                    END IF
                    IF ma_state%(j%) = 1 THEN
                        score% = score% + 10
                        IF state% = 4 THEN
                            safe_teleport% = safe_teleport% + 1
                            IF safe_teleport% > 10 THEN safe_teleport% = 10
                        END IF
                    END IF
                    ma_state%(i%) = 2
                    ma_state%(j%) = 2
                END IF
            NEXT j%
            IF ma_state%(i%) <> 2 THEN k% = 0
        NEXT i%
        IF k% = 1 THEN state% = 3
    END IF

    ' display
    FOR j% = 1 TO y_max%
        FOR i% = 1 TO x_max%
            l% = 0
            FOR k% = 1 TO ma_amount%
                IF ma_x%(k%) = i% AND ma_y%(k%) = j% THEN
                    l% = ma_state%(k%)
                    IF l% = 1 THEN l% = l% + 1 + k%
                END IF
            NEXT k%

            LOCATE j%, i%
            IF ((i% = 1) OR (i% = x_max%)) OR ((j% = 1) OR (j% = y_max%)) THEN
                COLOR 15: IF state% = 2 THEN COLOR 4
                PRINT "#"
            ELSEIF i% = qb_x% AND j% = qb_y% THEN
                COLOR 15: PRINT "Q"
            ELSEIF l% > 2 THEN
                SELECT CASE l% MOD 5
                    CASE 0 :COLOR 13
                    CASE 1 :COLOR 14
                    CASE 2 :COLOR 3
                    CASE 3 :COLOR 12
                    CASE 4 :COLOR 5
                END SELECT
                IF state% = 2 THEN COLOR 4
                SELECT CASE l% MOD 5
                    CASE 0 :PRINT "M"
                    CASE 1 :PRINT "M"
                    CASE 2 :PRINT "S"
                    CASE 3 :PRINT "K"
                    CASE 4 :PRINT "H"
                END SELECT
            ELSEIF l% = 2 THEN
                COLOR 6: PRINT "@"
            ELSE
                PRINT " "
            END IF
        NEXT i%
    NEXT j%

    LOCATE y_max%, 3
    COLOR 15
    PRINT " Energy =" + STR$(score%) + " "
    LOCATE y_max%, 43
    COLOR 15
    PRINT " Safe Teleports =" + STR$(safe_teleport%) + " "

    IF state% = 2 THEN
        COLOR 15
        IF qb_x% < (x_max% - 14) THEN
            LOCATE qb_y%, qb_x% + 1
            PRINT " < AIEEEEEE!?"
        ELSE
            LOCATE qb_y%, qb_x% - 13
            PRINT "AIEEEEEE!? > "
        END IF
        endwait% = endwait% + 1
    ELSEIF state% = 3 THEN
        COLOR 15
        IF qb_x% < (x_max% - 10) THEN
            LOCATE qb_y%, qb_x% + 1
            PRINT " < Yahoo!"
        ELSE
            LOCATE qb_y%, qb_x% - 9
            PRINT "Yahoo! > "
        END IF
        endwait% = endwait% + 1
    END IF
LOOP UNTIL endwait% = 60

IF state% = 2 THEN
    GOTO TITLE_SCREEN
ELSEIF state% = 3 THEN
    GOTO INIT_GAME
END IF

END

QB_DOT:
'---+---------------+---------------+---------------+---------------+---------------+
DATA 0,0,0,0,2,0,0,0,0,0,0,2,2,0,0,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,0,0,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,2,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2
DATA 0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,2,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
'---+---------------+---------------+---------------+---------------+---------------+
DATA 0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,2,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,2,2,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,2,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,2,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,1,3,3,1,1,3,3,1,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,2,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 2,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
'---+---------------+---------------+---------------+---------------+---------------+
DATA 2,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,2
DATA 0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,0
DATA 0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA 0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2

FUNCTION ANYKEY$
DO
    _LIMIT 30
    ANYKEY$ = INKEY$
LOOP UNTIL ANYKEY$ <> ""
END FUNCTION
